with Grt.Hierarchy; use Grt.Hierarchy;

package Grt.Errors is
   pragma Preelaborate (Grt.Errors);

   --  Multi-call error procedure.
   --  Start and continue with Error_C, finish by an Error_E.
   procedure Error_C (Str : String);
   procedure Error_C (N : Integer);
   procedure Error_C (Inst : Ghdl_Instance_Name_Acc);
   procedure Error_E (Str : String);
   pragma No_Return (Error_E);

   --  Multi-call report procedure.  Do not exit at end.
   procedure Report_H (Str : String);
   procedure Report_C (Str : String);
   procedure Report_C (N : Integer);
   procedure Report_E (Str : String);

   --  Complete error message.
   procedure Error (Str : String);

   --  Internal error.  The message must contain the subprogram name which
   --  has called this procedure.
   procedure Internal_Error (Msg : String);
   pragma No_Return (Internal_Error);

   --  Display a message which is not an error.
   procedure Info (Str : String);

   --  If true, an error is expected and the exit status is inverted.
   Expect_Failure : Boolean := False;

private
   pragma No_Return (Error);
end Grt.Errors;

