with Ortho_Front; use Ortho_Front;
with Iirs; use Iirs;

package Translation is
   --  Initialize the package: create internal nodes.
   procedure Initialize;

   --  Translate (generate code) for design unit UNIT.
   --  If MAIN is true, the unit is really the unit being compiled (not an
   --  external unit).  Code shouldn't be generated for external units.
   procedure Translate (Unit : Iir_Design_Unit; Main : Boolean);

   --  Translate std.standard.
   procedure Translate_Standard (Main : Boolean);

   --  Primary unit + secondary unit (architecture name which may be null)
   --  to elaborate.
   procedure Elaborate (Primary : String_Acc;
                        Secondary : String_Acc;
                        Filelist : String_Acc);
end Translation;
